<?php


namespace app\wx_url\controller;


use think\facade\Db;
use vitphp\admin\traits\Jump;

class Index
{
    use Jump;

    public function index()
    {
        $code = input('code');
        $url = Db::name('wx_url_list')->where(['code'=>$code])->find();
        if(!$url) $this->error('未知的链接');

        if($url['is_expire']==3 && $url['time'] < time()){
            $this->error('该链接已到期');
        }

        $ip = getip();
        $urlLog = Db::name('wx_url_log')->where([
            ['pid', '=', $url['pid']],
            ['code', '=', $url['code']],
            ['ip', '=', $ip],
            ['create_time', '<', time() + 86400*30]
        ])->find();
        if($urlLog){
            Db::name('wx_url_log')->where('id', $urlLog['id'])->update(['pv'=>Db::raw('pv+1')]);
            return redirect($urlLog['url']);
        }

        $config = [
            'appsecret' => $url['wxapp_appsecret'],
            'appid' => $url['wxapp_appid'],
        ];
        $mini = new \WeMini\Qrcode($config);
        $pathArr = $url['wxapp_path'] ? explode('?', $url['wxapp_path']) : [];
        if($pathArr){
            $path['path'] = $pathArr[0];
            $path['query'] = $pathArr[1] ?? '';
        }
        $path = $path ?? [];
        try {
            $wxapp = app_http_request("https://api.weixin.qq.com/wxa/generate_urllink?debug=1&access_token=" . $mini->getAccessToken(), $path, [], [], true);
        } catch (\Exception $e) {
            $this->error('有误：'.$e->getCode() . '-' . $e->getMessage());
        }
        $urlLink = json_str_to_array($wxapp);
        if ($urlLink["errcode"]=='0'){
            Db::name('wx_url_log')->insert([
                'pid' => $url['pid'],
                'code' => $url['code'],
                'ip' => $ip,
                'url' => $urlLink['url_link'],
                'pv' => 1,
                'create_time' => time()
            ]);
            return redirect($urlLink['url_link']);
        } else {
            $this->error('失败：'. $urlLink['errcode'] . '--' . $urlLink['errmsg']);
        }

        return '';
    }
}